<script lang="ts">
  import type { JSONValue } from '$lib';
  import { focusElement } from '$lib';
  import ConstantElement from '$lib/ConstantElement.svelte';
  import DeleteButton from '$lib/DeleteButton.svelte';

  // Define props
  export let value: { [key: string]: JSONValue };

  // Note: we can bind the values directly to the object values. We could do this using `{#each Object.entries(value) as [key, _]}`
  // However, we have to bind the keys to a separate variable in order to be able to update the object keys

  let keys = Object.keys(value);
  let oldKeys = [...keys]; // Copy by value instead of by reference

  $: handleKeysChange(keys);

  function handleKeysChange(newKeys: string[]) {
    // If one of the keys has changed, update the value object
    if (newKeys.length == oldKeys.length) {
      // In case the no keys have been added/removed: rename the changed keys
      for (let i = 0; i < newKeys.length; i++) {
        const oldKey = oldKeys[i],
          newKey = newKeys[i];
        if (newKey !== oldKey) {
          value[newKey] = value[oldKey];
          delete value[oldKey];
        }
      }
    } else if (newKeys.length > oldKeys.length) {
      // New key added (which we assume is the last key because of the UI): add it to the object
      value[newKeys[newKeys.length - 1]] = null;
    } else {
      // Key deleted: remove all keys that occur in oldKeys but not in newKeys
      for (const oldKey of oldKeys) {
        if (!newKeys.includes(oldKey)) {
          delete value[oldKey];
        }
      }
    }

    oldKeys = [...keys]; // Copy by value
  }

  // uniqueKey returns a key that does not occur in the keys array yet
  function uniqueKey(): string {
    let newKey = 'key';
    for (let i = 2; keys.includes(newKey); i++) {
      newKey = 'key' + i;
    }

    return newKey;
  }

  function deleteKey(i: number): undefined {
    keys.splice(i, 1);
    keys = keys; // Re-render the elements
  }
</script>

{#each keys as key, i (i)}
  <div class="mt-3 rounded-md border border-slate-200 px-4 py-2">
    <DeleteButton on:click={deleteKey(i)} extraClasses="mt-0" />
    <label class="font-medium text-gray-600"
      >Key:
      <input
        bind:value={keys[i]}
        use:focusElement
        type="text"
        class="inline-block w-80 rounded-lg border border-gray-300 p-2.5 font-normal text-gray-800 placeholder:text-gray-400 focus:border-indigo-500 focus:outline-none focus:ring-1 focus:ring-indigo-500"
        placeholder="Waarde van de constante"
        autocomplete="off"
      /></label
    >

    <!-- svelte-ignore a11y-label-has-associated-control -->
    <label class="mt-2 block font-medium text-gray-600">Value:</label>
    <ConstantElement bind:value={value[key]} />
  </div>
{:else}
  <p class="text-gray-500 mt-2">(Nog geen entries)</p>
{/each}

<p class="mt-4">
  <button
    on:click={() => {
      keys = [...keys, uniqueKey()];
    }}
    class="inline-flex items-center rounded-lg border border-indigo-300 bg-indigo-50 px-2.5 py-1.5 text-sm font-medium text-indigo-800 shadow-sm hover:border-indigo-400 hover:bg-indigo-100 hover:text-indigo-950 focus:outline-none focus:ring-4 focus:ring-indigo-200"
    type="button"
  >
    <svg class="-ml-0.5 mr-2 h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
      <path
        fill="none"
        stroke="currentColor"
        stroke-linecap="round"
        stroke-linejoin="round"
        stroke-width="2"
        d="M12 5v14m-7-7h14"
      />
    </svg>
    Voeg een entry toe
  </button>
</p>
